routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\TiendaController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\ProductotiendaController;
use Illuminate\Support\Facades\Route;

Route::controller(HomeController::class)->group(function () {
    Route::get('/', 'index')->name('index');
    Route::get('/index', 'index')->name('home.index');
});

Route::resource('tienda', TiendaController::class);
Route::resource('producto', ProductoController::class);
Route::resource('productoTienda', ProductotiendaController::class);

app/Models/Producto.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Schema;

class Producto extends Model {
    use HasFactory;

    protected $table = 'productos';
    protected $fillable = [
        'nombre',
        'precio',
    ];

    public function getFields() {
        return Schema::getColumnListing($this->table);
    }

    public static $labels = [
        'id' => 'ID Producto',
        'nombre' => 'Nombre Producto',
        'precio' => 'Precio Producto',
    ];

    public function productotiendas() : HasMany {
        return $this->hasMany(Productotienda::class);
    }

    public function getAttributeLabel($attribute) {
        return self::$labels[$attribute] ?? $attribute;
    }
}

app/Http/Controllers/ProductoController.php
<?php

namespace App\Http\Controllers;

use App\Models\Producto;
use Illuminate\Http\Request;

class ProductoController extends Controller {
    /**
     * Display a listing of the resource.
     */
    public function index() {
        //$productos = Producto::paginate(15);
        $productos = Producto::all();

        //dd($productos[0]->getAttributeLabel('nombre'));

        return view('producto.index', compact('productos'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create() {
        return view('producto.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request) {
        $request->validate([
            'nombre' => 'required|string',
            'precio' => 'required|numeric|max:1000',
        ], [
            'required' => 'El campo :attribute es obligatorio.',
            'numeric' => 'El campo :attribute debe ser un valor numérico.',
            'max' => 'El campo :attribute no debe ser mayor a :max.',
        ], [
            'nombre' => 'Nombre Producto',
            'precio' => 'Precio Producto',
        ]);

        $prducto = Producto::create($request->all());
        
        return redirect()
            ->route('producto.show', $prducto->id)
            ->with('mensaje', 'Pruducto creado con éxito')
        ;
    }

    /**
     * Display the specified resource.
     */
    public function show(int $id) {
        $producto = Producto::find($id);

        return view('producto.show', compact('producto'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(int $id) {
        $producto = Producto::find($id);

        return view('producto.edit', compact('producto'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Producto $producto) {
        $request->validate([
            'nombre' => 'required|string',
            'precio' => 'required|numeric|max:1000',
        ], [
            'required' => 'El campo :attribute es obligatorio.',
            'numeric' => 'El campo :attribute debe ser un valor numérico.',
            'max' => 'El campo :attribute no debe ser mayor a :max.',
        ], [
            'nombre' => 'Nombre',
            'precio' => 'Precio',
        ]);

        $producto->update($request->all());

        return redirect()
            ->route('producto.show', $producto->id)
            ->with('mensaje', 'Prouducto actualizado con éxito')
        ;
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Producto $producto) {
        $producto->delete();
        
        return redirect()
            ->route('producto.index')
            ->with('mensaje', 'Producto borrado con éxito')
        ;
    }
}

resources/views/producto/create.blade.php
@extends('layouts.main')

@section('titulo', 'Crear Producto')

@section('cabecera')
    <x-cabecera subTitulo="">
        <i class="fa-brands fa-r-project"></i> Crear Producto
    </x-cabecera>
@endsection

@section('contenido')
    <x-formularios.formulario :errors="$errors" route="{{ route('producto.store') }}">
        <x-formularios.input type="text" label="Nombre" name="nombre" :value="old('nombre')"/>
        <x-formularios.input type="number" label="Precio" name="precio" :value="old('precio')"/>
    </x-formularios.formulario>
@endsection

resources/views/producto/edit.blade.php
@extends('layouts.main')

@section('titulo', 'Editar Producto')

@section('contenido')
    <ul class="nav nav-tabs mb-5">
        <li class="nav-item">
            <a class="nav-link" aria-current="page" href="{{ route('producto.show', $producto->id) }}">Producto {{ $producto->id }}</a>
        </li>

        <li class="nav-item">
            <a class="nav-link active disabled" aria-disabled="true" href="{{ route('producto.edit', $producto->id) }}">Editar Producto</a>
        </li>
        
        <li class="nav-item" style="margin-left: auto;">
            <a class="nav-link" aria-current="page" href="{{ route('producto.show', $producto->id) }}">Volver</a>
        </li>
    </ul>

    @if (session('mensaje'))
        <div class="card gradient-for-card-se mb-4">
            <div class="card-body text-center" style="background-color: #0e1321">
                <p class="card-text lead fs-4">{{ session('mensaje') }} </p>
            </div>
        </div>
    @endif
    
    <x-formularios.formulario :modelo="$producto" :errors="$errors" method="PUT" route="{{ route('producto.update', $producto->id) }}">
        <x-formularios.input type="text" label="Nombre" name="nombre" :value="old('nombre', $producto->nombre)"/>
        <x-formularios.input type="text" label="Precio" name="precio" :value="old('precio', $producto->precio)"/>
    </x-formularios.formulario>
@endsection

resources/views/producto/index.blade.php
@extends('layouts.main')

@section('titulo', 'Tiendas')

@section('cabecera')
    <x-cabecera subTitulo="Listado de Productos">
        <i class="fa-brands fa-r-project"></i> Listado de Productos
    </x-cabecera>
@endsection

@section('contenido')

@if (session('mensaje'))
    <div class="card gradient-for-card-se mb-2">
        <div class="card-body text-center" style="background-color: #0e1321">
            <p class="card-text lead fs-4"> {{ session('mensaje') }} </p>
        </div>
    </div>
@endif

<x-listView  :registros="$productos" modelo="producto" :campos="['id', 'nombre', 'precio']" />

@endsection

@section('pie')
    <x-pie datos="Copyright 2024, Aaron Terry - Todos los derechos reservados" />
@endsection

resources/views/producto/show.blade.php
@extends('layouts.main')

@section('titulo', 'Mostrar')

@section('contenido')
<div class="row">
    <ul class="nav nav-tabs">
        <li class="nav-item">
            <a class="nav-link active disabled" aria-disabled="true">Producto {{ $producto->id }}</a>
        </li>
    
        <li class="nav-item">
            <a class="nav-link" href="{{ route('producto.edit', $producto->id) }}">Editar Producto</a>
        </li>
        
        <li class="nav-item" style="margin-left: auto;">
            <a class="nav-link" aria-current="page" href="{{ route('producto.index') }}">Volver</a>
        </li>
    </ul>

    @if (session('mensaje'))
        <div class="card gradient-for-card-se mt-4">
            <div class="card-body text-center" style="background-color: #0e1321">
                <p class="card-text lead fs-4"> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif
    
    <div class="col-lg-10 my-4 mb-sm-0 offset-lg-1">
        <div class="card text-center listadoTarjetaCliente">
            <div class="card-header">
                <span class="fs-3 text-center text-is-gradient">Producto {{ $producto->id }}</span>
            </div>

            <div class="card-body text-center">
                <i class="fa-brands fa-product-hunt fa-5x profile-pic text-gradient-primary mb-2"></i>
                <h4 class="card-title font-italic nombreListadoCliente my-4">{{ $producto->nombre }}</h4>

                <div class="row">
                    <div class="col-lg-12">
                        <div class="list-group">
                            <div class="list-group-item d-flex justify-content-between align-items-center p-3">
                                <span class="fw-bold text-uppercase">Precio:</span>
                                <span class="ms-auto">{{ $producto->precio }}</span>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="my-4 d-flex justify-content-center align-items-center">
                    <a class="btn btn-outline-success me-2" href="{{ route('producto.edit', $producto->id) }}" role="button">Editar</a>
                    
                    <form action="{{ route('producto.destroy', $producto)}}" method="POST">
                        @csrf @method('DELETE')
                        <button type="submit" class="btn btn-outline-danger">Borrar</button>
                    </form>      
                </div>
            </div>
        </div>
        <div class="gradient-for-card-tb"></div>
    </div>
</div>
@endsection